module CollisionDetector (SEG1, SEG2, SEG3, SEG4, SNAKEX, SNAKEY, APPLEX, APPLEY, RESET, CLK, GAMEOVER, GROW) ;

input [11:0] SEG1 ;
input [11:0] SEG2 ;
input [11:0] SEG3 ;
input [11:0] SEG4 ;
input [9:0] SNAKEX ;
input [9:0] SNAKEY ;
input [9:0] APPLEX ;
input [9:0] APPLEY ;
input RESET ;
input CLK ;
output GAMEOVER ;
output GROW ;

// add your declarations here
reg [11:0] SEG1_2, SEG1_3, SEG1_4;
reg [11:0] SEG2_2, SEG2_3, SEG2_4;
reg [11:0] SEG3_2, SEG3_3, SEG3_4;
reg [11:0] SEG4_2, SEG4_3, SEG4_4;

reg [9:0] SNAKEX_2, SNAKEX_3, SNAKEX_4;
reg [9:0] SNAKEY_2, SNAKEY_3, SNAKEY_4;

reg [9:0] APPLEX_2, APPLEX_3, APPLEX_4;
reg [9:0] APPLEY_2, APPLEY_3, APPLEY_4;

reg gameover1, gameover2, gameover3, gameover4;
reg grow1, grow2, grow3, grow4;


assign GAMEOVER = gameover4;
assign GROW = grow4;


always @(posedge CLK) begin

if (RESET) begin
  gameover1 <= 0;
  gameover2 <= 0;
  gameover3 <= 0;
  gameover4 <= 0;
    
  grow1 <= 0;
  grow2 <= 0;
  grow3 <= 0;
  grow4 <= 0;
end

else begin

  // Stage 1
  if (SEG1[11:10] == 0) begin
    
    if((APPLEY >= SNAKEY) && (APPLEY <= SNAKEY + 2) && (APPLEX <= SNAKEX + 10) && (APPLEX >= SNAKEX - 10))
      grow1 <= 1;
    else
      grow1 <= 0;
      
    if( SNAKEY  <= 10)  //checking top boundary
      gameover1 <= 1;
    else
      gameover1 <= 0;
  end
  else begin
      grow1 <= 0;
      gameover1 <= 0;
  end

  SEG1_2 <= SEG1;
  SEG2_2 <= SEG2;
  SEG3_2 <= SEG3;
  SEG4_2 <= SEG4;
  
  SNAKEX_2 <= SNAKEX;
  SNAKEY_2 <= SNAKEY;
  
  APPLEX_2 <= APPLEX;
  APPLEY_2 <= APPLEY;
  
  
  // Stage 2		   	
  if (SEG1_2[11:10] == 1) begin
 
    if((APPLEY_2 <= SNAKEY_2) && (APPLEY_2 >= SNAKEY_2 - 2) && (APPLEX_2 <= SNAKEX_2 + 10) && (APPLEX_2 >= SNAKEX_2 - 10))
      grow2 <= 1;	
    else
      grow2 <= grow1;
		   
    if( SNAKEY_2  >= 470)   //checking bottom boundary
      gameover2 <= 1;
    else
      gameover2 <= gameover1;
  end
  else begin
    grow2 <= grow1;
    gameover2 <= gameover1;
  end
  
  SEG1_3 <= SEG1_2;
  SEG2_3 <= SEG2_2;
  SEG3_3 <= SEG3_2;
  SEG4_3 <= SEG4_2;
  
  SNAKEX_3 <= SNAKEX_2;
  SNAKEY_3 <= SNAKEY_2;
  
  APPLEX_3 <= APPLEX_2;
  APPLEY_3 <= APPLEY_2;
  
  
  // Stage 3
  if (SEG1_3[11:10] == 2) begin

    if((APPLEY_3 <= SNAKEY_3 + 10) && (APPLEY_3 >= SNAKEY_3 - 10) && (APPLEX_3 >= SNAKEX_3) && (APPLEX_3 <= SNAKEX_3 + 2))
      grow3 <= 1;
    else
      grow3 <= grow2;

    if ( SNAKEX_3  <= 10)  //checking left boundary
      gameover3 <= 1;
    else
      gameover3 <= gameover2;
  end
  else begin 
    grow3 <= grow2;
    gameover3 <= gameover2;
  end
  
  SEG1_4 <= SEG1_3;
  SEG2_4 <= SEG2_3;
  SEG3_4 <= SEG3_3;
  SEG4_4 <= SEG4_3;
  
  SNAKEX_4 <= SNAKEX_3;
  SNAKEY_4 <= SNAKEY_3;
  
  APPLEX_4 <= APPLEX_3;
  APPLEY_4 <= APPLEY_3;
  
  
  // Stage 4
  if (SEG1_4[11:10] == 3) begin 
  
    if((APPLEY_4 <= SNAKEY_4 + 10) && (APPLEY_4 >= SNAKEY_4 - 10) && (APPLEX_4 <= SNAKEX_4) && (APPLEX_4 >= SNAKEX_4 - 2))
      grow4 <= 1;
    else 
      grow4 <= grow3;
      
    if( SNAKEX_4  >= 630)    //checking right boundary
      gameover4 <= 1;
    else
      gameover4 <= gameover3;
  end
  else begin
    grow4 <= grow3;
    gameover4 <= gameover3;
  end
    
end
end
endmodule 
