module pmover (keyup, keydown, keyleft, keyright, freezekey, clk, reset, yposition, UpDown, xposition, leftRight) ;

input keyup ;
input keydown ;
input keyleft;
input keyright;
input freezekey;
input clk ;
input reset ;
output [8:0] yposition ;
output [1:0] UpDown ;
output [8:0] xposition;
output [1:0] leftRight;

// add your declarations here
reg [15:0] count;
reg [8:0] _xposition, _yposition;
assign yposition = _yposition;
assign xposition = _xposition;

reg moveup;
reg move;
reg [1:0] _UpDown;
assign UpDown = _UpDown;  // UpDown = 0 move down
			  //	    = 1 move not moving
			  // 	    = 2 move up
reg [1:0] _leftRight;
assign leftRight = _leftRight; 	  // leftRight = 0 move left
 				  //	       = 1 move not moving
				  // 	       = 2 move right

always@(posedge clk)begin
	if(reset) begin
		_UpDown <= 1;
		_leftRight <= 1;
	end else begin
		if(keyup) begin
			_UpDown <= 2;
		end
		else if(keydown) begin
			_UpDown <= 0;
		end
		else if(keyleft) begin
			_leftRight <= 0;
		end
		else if(keyright) begin
			_leftRight <= 2;
		end
		else if (freezekey) begin
			_leftRight <= 1;
			_UpDown <=1;
		end
	end
end

//update a counter
always @(posedge clk) begin
	count <= count + 1;
end


always@(posedge clk) begin
	if(reset)begin
		_yposition = 10;
		_xposition = 160;
	end
	else begin
		if (count==0 & _UpDown == 0 & _yposition < 438) begin
			_yposition = _yposition + 1;
		end
		else if (count==0 & _UpDown == 2 & _yposition > 10) begin
			_yposition = _yposition - 1;
		end
		if(count==0 & _leftRight == 2 & _xposition < 312) begin
			_xposition = _xposition + 1;
		end
		else if (count==0 & _leftRight == 0 & _xposition > 0) begin
			_xposition = _xposition - 1;
		end
	end
		
end


endmodule 
