module TETRIS (CLK, VH, VRGB, ROUT, GOUT, BOUT) ;

input CLK ;
input VH ;
input VRGB;  // y synch
output ROUT ;
output GOUT ;
output BOUT ;

// Tetris declarations
reg [127:0] ROW;

// active piece
reg [2:0] activex;  // 3-bits -- horizontal, 4-bits -- vertical
reg [6:0] activey;  // 3-bits -- horizontal, 4-bits -- vertical

reg [1:0] active2;  // 2-bits for additional piece
reg [1:0] active3;  // 2-bits for additional piece
reg [1:0] active4;  // 2-bits for additional piece

reg [2:0] state;   //determine if we need a new active piece

reg [4:0] piece;     // used to simulate random piece generation

reg [9:0] Xcounter;
reg [9:0] Ycounter;

reg [2:0] tempX;	//temp holding vars to split up shifting and compares
reg [6:0] tempY;

//reg [6:0] box;
reg [3:0] Counter;
reg [6:0] ActiveSpot;
reg [6:0] ActiveNext;
reg R;
reg G;
reg B;

assign ROUT = R;
assign GOUT = G;
assign BOUT = B;
 
// Welcome to Tetris
always@(posedge CLK) begin

if(!VRGB) begin
  Xcounter <= 0; 
  Ycounter <= 0;

//  ROW[0] <= 1;
//  ROW[2] <= 1;
//  ROW[4] <= 1;
//  ROW[6] <= 1;
//  ROW[9] <= 1;  
//  ROW[11] <= 1;  
//  ROW[13] <= 1;  
//  ROW[15] <= 1;  
//  ROW[16] <= 1;  
//  ROW[18] <= 1;  
//  ROW[20] <= 1;  
//  ROW[22] <= 1;  
//  ROW[25] <= 1;  
//  ROW[27] <= 1;  
//  ROW[29] <= 1;  
//  ROW[31] <= 1;  

//  ROW[32] <= 1;

//  ROW[48] <= 1;


//  ROW[76] <= 1;


//  ROW[96] <= 1;



//  ROW[123] <= 1;
      
end
else
if(VH) begin

if(Xcounter == 1 && Ycounter == 1)
  Counter <= Counter + 1;

if(Xcounter > 253 && Xcounter < 383 && Ycounter > 111 && Ycounter < 368)
begin
//draw board to screen

tempX <= (Xcounter - 254) >> 4;
tempY <= (Ycounter - 112) >> 4;

	if(Xcounter == 254) begin
		R <= 0;  // draw green background (hack to fix red piece overflow)
 	  	G <= 1;
	        B <= 0;
	end
	else begin

		if(ROW[(tempY << 3) | tempX])
			begin
			   R <= 1;  // draw red dead pieces
	 	  	   G <= 0;
			   B <= 0;
			end
		else begin
		
			if((tempY == activey) && (tempX == activex)) begin
			   R <= 1;  // draw yellow active piece
	 	  	   G <= 1;
			   B <= 0;
			end
		
			else
			begin
			   R <= 0;  // draw black empty square
			   G <= 0;
			   B <= 0;
			end
		end
	end
end
else //draw green and calculate next game state;

begin
	R <= 0;  // draw green background
	G <= 1;	
	B <= 0;
  
case(state)

0:begin
	activex <= 3;
	activey <= 0;
	
//	case(piece)
//	0:begin  //4 long
//		active2 <= 2;
//		active3 <= 2;
//		active4 <= 2;
//	end
	
//	1:begin //box
//		active2 <= 3;
//		active3 <= 2;
//		active4 <= 1;
//	end
//	2:begin //left L
//		active2 <= 2;
//		active3 <= 2;
//		active4 <= 1;
//	end
//	3:begin //right L
//		active2 <= 2;
//		active3 <= 2;
//		active4 <= 3;
//	end
//	4:begin //left Z
//		active2 <= 2;
//		active3 <= 3;
//		active4 <= 2;
//	end
//	5:begin //right Z
//		active2 <= 2;
//		active3 <= 1;
//		active4 <= 2;
//	end

//	endcase
	
	state <= 1;
end

1:begin

/*
   if(Counter == 10) begin
	Counter <= 0;
	activey <= activey + 1;
   end

	case(Counter)
	1:begin
	   ActiveSpot <= ((activey << 3) | activex);
	  end
	5:begin
	   ActiveNext <= ActiveSpot + 8;
	  end
	7:begin
	     if((activey == 15) || (ROW[ActiveNext])) begin
	     ROW[ActiveSpot] <= 1;
//	    if(activey == 0)
//	      state <= 2;  // game over
//	    else
	      state <= 0;
	   end
   	  end
	15:begin
	   Counter <= 0;
	   activey <= activey + 1;
	   end
	endcase

//	else if(ROW[ActiveSpot + 8])
//	  begin
//	    ROW[ActiveSpot] <= 1;
	//case(active2)
	  //  0:begin
	    //  ROW[ActiveSpot - 8] <= 1;
	    //end
	    //1:begin
	     // ROW[ActiveSpot - 1] <= 1;
	    //end
	    //2:begin
	    //  ROW[ActiveSpot + 8] <= 1;	   
	    //end
	    //3:begin
	    //  ROW[ActiveSpot + 1] <= 1;	   	   
//	    state <= 0; 
//	    end

*/	
end // to if(counter == 15)    	



2:begin  // game over
	ROW <= 0;  // clear board
	state <= 0; // reset game
end

//3:begin

//end

endcase


end  //end calculate game state



//see if we are off the drawing area, if we are, reset.
if(Xcounter < 639) 
  begin
  Xcounter <= Xcounter + 1;
  end
else
  begin
    Xcounter <= 0;
    Ycounter <= Ycounter + 1;
  end
 
//"randomize" next piece to choose
//if(piece < 5)
//  piece <= piece + 1;
//else
//  piece <= 0;  
end
end

endmodule 
